/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.data;

import android.database.Cursor;
import android.text.TextUtils;
import android.util.Log;

import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.DataColumns;
import net.micode.notes.data.Notes.DataConstants;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.gtask.exception.ActionFailureException;
import net.micode.notes.tool.GTaskStringUtils;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;


public class Task extends Node {
    private static final String TAG = Task.class.getSimpleName(); // 定义一个私有静态常量TAG，值为Task.class.getSimpleName()

    private boolean mCompleted; // 定义一个私有的boolean类型变量mCompleted

    private String mNotes; // 定义一个私有的String类型变量mNotes

    private JSONObject mMetaInfo; // 定义一个私有的JSONObject类型变量mMetaInfo

    private Task mPriorSibling; // 定义一个私有的Task类型变量mPriorSibling

    private TaskList mParent; // 定义一个私有的TaskList类型变量mParent

    public Task() { // 定义一个公有的无参构造方法Task()
        super(); // 调用父类的无参构造方法
        mCompleted = false; // 将mCompleted变量初始化为false
        mNotes = null; // 将mNotes变量初始化为null
        mPriorSibling = null; // 将mPriorSibling变量初始化为null
        mParent = null; // 将mParent变量初始化为null
        mMetaInfo = null; // 将mMetaInfo变量初始化为null
    }



    public JSONObject getCreateAction(int actionId) {
        JSONObject js = new JSONObject(); // 创建一个JSONObject对象js

        try {
            // action_type
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE, GTaskStringUtils.GTASK_JSON_ACTION_TYPE_CREATE);
            // 将键为GTASK_JSON_ACTION_TYPE的值设置为"create"

            // action_id
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId);
            // 将键为GTASK_JSON_ACTION_ID的值设置为actionId

            // index
            js.put(GTaskStringUtils.GTASK_JSON_INDEX, mParent.getChildTaskIndex(this));
            // 将键为GTASK_JSON_INDEX的值设置为当前任务在父列表中的位置

            // entity_delta
            JSONObject entity = new JSONObject(); // 创建一个JSONObject对象entity
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName()); // 将键为GTASK_JSON_NAME的值设为任务名
            entity.put(GTaskStringUtils.GTASK_JSON_CREATOR_ID, "null"); // 将键为GTASK_JSON_CREATOR_ID的值设为"null"
            entity.put(GTaskStringUtils.GTASK_JSON_ENTITY_TYPE, GTaskStringUtils.GTASK_JSON_TYPE_TASK); // 将键为GTASK_JSON_ENTITY_TYPE的值设为"task"
            if (getNotes() != null) { // 如果备注信息不为空
                entity.put(GTaskStringUtils.GTASK_JSON_NOTES, getNotes()); // 将键为GTASK_JSON_NOTES的值设为备注信息
            }
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity); // 将键为GTASK_JSON_ENTITY_DELTA的值设为entity

            // parent_id
            js.put(GTaskStringUtils.GTASK_JSON_PARENT_ID, mParent.getGid()); // 将键为GTASK_JSON_PARENT_ID的值设为父列表的唯一标识符

            // dest_parent_type
            js.put(GTaskStringUtils.GTASK_JSON_DEST_PARENT_TYPE, GTaskStringUtils.GTASK_JSON_TYPE_GROUP);
            // 将键为GTASK_JSON_DEST_PARENT_TYPE的值设为"group"

            // list_id
            js.put(GTaskStringUtils.GTASK_JSON_LIST_ID, mParent.getGid()); // 将键为GTASK_JSON_LIST_ID的值设为父列表的唯一标识符

            // prior_sibling_id
            if (mPriorSibling != null) { // 如果前一个兄弟节点不为空
                js.put(GTaskStringUtils.GTASK_JSON_PRIOR_SIBLING_ID, mPriorSibling.getGid()); // 将键为GTASK_JSON_PRIOR_SIBLING_ID的值设为前一个兄弟节点的唯一标识符
            }

        } catch (JSONException e) { // 捕捉JSONException异常
            Log.e(TAG, e.toString()); // 在日志中输出异常信息
            e.printStackTrace();
            throw new ActionFailureException("fail to generate task-create jsonobject"); // 抛出ActionFailureException异常
        }

        return js; // 返回JSONObject对象js
    }

    public JSONObject getUpdateAction(int actionId) {
        JSONObject js = new JSONObject(); // 创建一个JSONObject对象js

        try {
            // action_type
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE, GTaskStringUtils.GTASK_JSON_ACTION_TYPE_UPDATE);
            // 将键为GTASK_JSON_ACTION_TYPE的值设置为"update"

            // action_id
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId);
            // 将键为GTASK_JSON_ACTION_ID的值设置为actionId

            // id
            js.put(GTaskStringUtils.GTASK_JSON_ID, getGid());
            // 将键为GTASK_JSON_ID的值设置为当前任务的唯一标识符

            // entity_delta
            JSONObject entity = new JSONObject(); // 创建一个JSONObject对象entity
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName()); // 将键为GTASK_JSON_NAME的值设为任务名
            if (getNotes() != null) { // 如果备注信息不为空
                entity.put(GTaskStringUtils.GTASK_JSON_NOTES, getNotes()); // 将键为GTASK_JSON_NOTES的值设为备注信息
            }
            entity.put(GTaskStringUtils.GTASK_JSON_DELETED, getDeleted()); // 将键为GTASK_JSON_DELETED的值设置为任务是否被删除的状态
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity); // 将键为GTASK_JSON_ENTITY_DELTA的值设为entity

        } catch (JSONException e) { // 捕捉JSONException异常
            Log.e(TAG, e.toString()); // 在日志中输出异常信息
            e.printStackTrace();
            throw new ActionFailureException("fail to generate task-update jsonobject"); // 抛出ActionFailureException异常
        }

        return js; // 返回JSONObject对象js
    }

    public void setContentByRemoteJSON(JSONObject js) {
        if (js != null) {  // 如果参数不为空
            try {
                // 获取Google Task的ID并设置到本地笔记或任务中
                if (js.has(GTaskStringUtils.GTASK_JSON_ID)) {
                    setGid(js.getString(GTaskStringUtils.GTASK_JSON_ID));
                }

                // 获取Google Task的最后修改时间戳并设置到本地笔记或任务中
                if (js.has(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED)) {
                    setLastModified(js.getLong(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED));
                }

                // 获取Google Task的名称并设置到本地笔记或任务中
                if (js.has(GTaskStringUtils.GTASK_JSON_NAME)) {
                    setName(js.getString(GTaskStringUtils.GTASK_JSON_NAME));
                }

                // 获取Google Task的备注信息并设置到本地笔记或任务中
                if (js.has(GTaskStringUtils.GTASK_JSON_NOTES)) {
                    setNotes(js.getString(GTaskStringUtils.GTASK_JSON_NOTES));
                }

                // 获取Google Task的删除状态并设置到本地笔记或任务中
                if (js.has(GTaskStringUtils.GTASK_JSON_DELETED)) {
                    setDeleted(js.getBoolean(GTaskStringUtils.GTASK_JSON_DELETED));
                }

                // 获取Google Task的完成状态并设置到本地笔记或任务中
                if (js.has(GTaskStringUtils.GTASK_JSON_COMPLETED)) {
                    setCompleted(js.getBoolean(GTaskStringUtils.GTASK_JSON_COMPLETED));
                }
            } catch (JSONException e) { // 如果解析过程出现异常
                // 记录异常日志并抛出异常
                Log.e(TAG, e.toString());
                e.printStackTrace();
                throw new ActionFailureException("fail to get task content from jsonobject");
            }
        }
    }

    public void setContentByLocalJSON(JSONObject js) {
        if (js == null || !js.has(GTaskStringUtils.META_HEAD_NOTE)
                || !js.has(GTaskStringUtils.META_HEAD_DATA)) { // 如果参数为空或缺少必要的数据字段
            Log.w(TAG, "setContentByLocalJSON: nothing is available"); // 记录警告日志
        }

        try {
            // 从JSON对象中获取笔记和数据数组
            JSONObject note = js.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);
            JSONArray dataArray = js.getJSONArray(GTaskStringUtils.META_HEAD_DATA);

            // 检查笔记类型是否为笔记类型
            if (note.getInt(NoteColumns.TYPE) != Notes.TYPE_NOTE) {
                Log.e(TAG, "invalid type"); // 记录错误日志
                return; // 返回
            }

            // 遍历数据数组
            for (int i = 0; i < dataArray.length(); i++) {
                JSONObject data = dataArray.getJSONObject(i); // 获取数据对象
                // 如果数据的MIME类型是笔记类型
                if (TextUtils.equals(data.getString(DataColumns.MIME_TYPE), DataConstants.NOTE)) {
                    setName(data.getString(DataColumns.CONTENT)); // 设置笔记名称
                    break; // 跳出循环
                }
            }

        } catch (JSONException e) { // 如果解析过程出现异常
            Log.e(TAG, e.toString()); // 记录异常日志
            e.printStackTrace(); // 打印异常堆栈信息
        }
    }

    public JSONObject getLocalJSONFromContent() {
        String name = getName(); // 获取名称
        try {
            if (mMetaInfo == null) { // 如果元信息为空
                // 从Web创建新任务
                if (name == null) { // 如果名称为空
                    Log.w(TAG, "the note seems to be an empty one"); // 记录警告日志
                    return null; // 返回null
                }

                // 创建JSON对象，并填充数据
                JSONObject js = new JSONObject();
                JSONObject note = new JSONObject();
                JSONArray dataArray = new JSONArray();
                JSONObject data = new JSONObject();
                data.put(DataColumns.CONTENT, name); // 设置数据内容为名称
                dataArray.put(data);
                js.put(GTaskStringUtils.META_HEAD_DATA, dataArray);
                note.put(NoteColumns.TYPE, Notes.TYPE_NOTE);
                js.put(GTaskStringUtils.META_HEAD_NOTE, note);
                return js; // 返回JSON对象
            } else {
                // 同步的任务
                JSONObject note = mMetaInfo.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);
                JSONArray dataArray = mMetaInfo.getJSONArray(GTaskStringUtils.META_HEAD_DATA);

                // 遍历数据数组
                for (int i = 0; i < dataArray.length(); i++) {
                    JSONObject data = dataArray.getJSONObject(i);
                    // 如果数据的MIME类型是笔记类型
                    if (TextUtils.equals(data.getString(DataColumns.MIME_TYPE), DataConstants.NOTE)) {
                        data.put(DataColumns.CONTENT, getName()); // 设置数据内容为名称
                        break; // 跳出循环
                    }
                }

                note.put(NoteColumns.TYPE, Notes.TYPE_NOTE);
                return mMetaInfo; // 返回元信息对象
            }
        } catch (JSONException e) { // 如果解析过程出现异常
            Log.e(TAG, e.toString()); // 记录异常日志
            e.printStackTrace(); // 打印异常堆栈信息
            return null; // 返回null
        }
    }

    public void setMetaInfo(MetaData metaData) {
        if (metaData != null && metaData.getNotes() != null) { // 如果元数据不为空且笔记不为空
            try {
                mMetaInfo = new JSONObject(metaData.getNotes()); // 将笔记转换为JSON对象
            } catch (JSONException e) { // 如果转换过程出现异常
                Log.w(TAG, e.toString()); // 记录警告日志
                mMetaInfo = null; // 设置元信息为空
            }
        }
    }

    //获取同步操作类型
    public int getSyncAction(Cursor c) {
        try {
            JSONObject noteInfo = null;
            if (mMetaInfo != null && mMetaInfo.has(GTaskStringUtils.META_HEAD_NOTE)) {
                noteInfo = mMetaInfo.getJSONObject(GTaskStringUtils.META_HEAD_NOTE); // 获取笔记信息对象
            }

            if (noteInfo == null) {
                Log.w(TAG, "it seems that note meta has been deleted"); // 记录警告日志
                return SYNC_ACTION_UPDATE_REMOTE; // 返回更新远程操作
            }

            if (!noteInfo.has(NoteColumns.ID)) {
                Log.w(TAG, "remote note id seems to be deleted"); // 记录警告日志
                return SYNC_ACTION_UPDATE_LOCAL; // 返回更新本地操作
            }

            // 验证笔记ID是否匹配
            if (c.getLong(SqlNote.ID_COLUMN) != noteInfo.getLong(NoteColumns.ID)) {
                Log.w(TAG, "note id doesn't match"); // 记录警告日志
                return SYNC_ACTION_UPDATE_LOCAL; // 返回更新本地操作
            }

            if (c.getInt(SqlNote.LOCAL_MODIFIED_COLUMN) == 0) {
                // 没有本地更新
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                    // 两边都没有更新
                    return SYNC_ACTION_NONE; // 返回无操作
                } else {
                    // 应用远程更新到本地
                    return SYNC_ACTION_UPDATE_LOCAL; // 返回更新本地操作
                }
            } else {
                // 验证gtask id是否匹配
                if (!c.getString(SqlNote.GTASK_ID_COLUMN).equals(getGid())) {
                    Log.e(TAG, "gtask id doesn't match"); // 记录错误日志
                    return SYNC_ACTION_ERROR; // 返回错误操作
                }
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                    // 只有本地修改
                    return SYNC_ACTION_UPDATE_REMOTE; // 返回更新远程操作
                } else {
                    return SYNC_ACTION_UPDATE_CONFLICT; // 返回更新冲突操作
                }
            }
        } catch (Exception e) { // 如果过程中出现异常
            Log.e(TAG, e.toString()); // 记录错误日志
            e.printStackTrace(); // 打印异常堆栈信息
        }

        return SYNC_ACTION_ERROR; // 返回错误操作
    }
    public boolean isWorthSaving() {
        return mMetaInfo != null || (getName() != null && getName().trim().length() > 0)
                || (getNotes() != null && getNotes().trim().length() > 0);
    }//判断任务是否值得保存

    public void setCompleted(boolean completed) {
        this.mCompleted = completed;
    }//设置任务是否已完成

    public void setNotes(String notes) {
        this.mNotes = notes;
    }//设置任务的笔记

    public void setPriorSibling(Task priorSibling) {
        this.mPriorSibling = priorSibling;
    }//设置任务的前一个兄弟任务

    public void setParent(TaskList parent) {
        this.mParent = parent;
    }//设置任务的父任务列表

    public boolean getCompleted() {
        return this.mCompleted;
    }//获取任务是否已完成

    public String getNotes() {
        return this.mNotes;
    }//获取任务的笔记

    public Task getPriorSibling() {
        return this.mPriorSibling;
    }//获取任务的前一个兄弟任务

    public TaskList getParent() {
        return this.mParent;
    }//获取任务的父任务列表

}
